import asyncdispatch, json, options, dimscord, strutils, harpoon, os, db_sqlite, strformat, tables
from uri import parseUri
discard os.execShellCmd("clear")
let
  keyfile = readFile("token.key")
  discord = newDiscordClient(keyfile)
  prefix = "$"
proc onReady(s: Shard, r: Ready) {.event(discord).} =
  echo "Login on " & $r.user

proc messageCreate(s: Shard, m: Message) {.event(discord).} =
  if m.author.bot: return
  if not m.content.startsWith(prefix): return
  let
    args = m.content.toLowerAscii().substr(prefix.len).split(" ")
    argument = m.content.split(" ")
  case args[0]:
    of "help":
      discard await discord.api.sendMessage(
        m.channel_id,
        embeds = @[Embed(
          title: some "TaxenHeimer Bot",
          fields: some @[EmbedField(
            name: fmt"**{prefix}help**",
            value: "`Displays this menu`",
            inline: some true
          ),
          EmbedField(
            name: fmt"**{prefix}namemc**",
            value: "`Displays informations about a minecraft account`",
            inline: some true
          ),
          EmbedField(
            name: fmt"**{prefix}status**",
            value: "`Gives overall informations on the database`",
            inline: some true
          )],
          color: some 0x000066
        )]
      )
    of "namemc":
      if (argument.len < 2):
        discard await discord.api.sendMessage(m.channel_id, "User not found")
      else:
        let
          url = "https://api.ashcon.app/mojang/v2/user/" & argument[1]
          data = getJson(parseUri(url))
        if (data{"code"}.getInt == 404):
          discard await discord.api.sendMessage(m.channel_id, "User not found")
        else:
          var
            uuid = data["uuid"].getStr
            renderurl = "https://crafatar.com/avatars/" & uuid
            bodyurl = "https://crafatar.com/renders/body/" & uuid
            username = data["username"].getStr
            date = data{"created_at"}.getStr
            usernamehistory = data["username_history"]
            hist = ""
          if (usernamehistory.len > 0):
            for names in usernamehistory:
              if (names{"changed_at"}.isNil):
                hist.add(names["username"].getStr & " : " & "Original\n")
              else:
                var
                  cdate = names{"changed_at"}.getStr.split("T")
                  pdate = cdate[1].split(".")[0] & " " & cdate[0]
                hist.add(names["username"].getStr & " : " & pdate & "\n")
          else:
            hist.add("No Name History")
          discard await discord.api.sendMessage(
            m.channel_id,
            embeds = @[Embed(
              title: some "Namemc Lookup",
              fields: some @[EmbedField(
                  name: "**username**",
                  value: fmt"```{'\n'}{username}{'\n'}```",
                  inline: some true
                ),
                EmbedField(
                  name: "**UUID**",
                  value: fmt"```{'\n'}{uuid}{'\n'}```",
                  inline: some true
                ),
                EmbedField(
                  name: "**Creation Date(Might not be given)**",
                  value: fmt"```{'\n'}{date}{'\n'}```",
                  inline: some true
                ),
                EmbedField(
                  name: "**Name History**",
                  value: fmt"```fix{'\n'}{hist}{'\n'}```",
                  inline: some false
                )
              ],
              thumbnail: some EmbedThumbnail(
                url: some renderurl
              ),
              image: some EmbedImage(
                url: some bodyurl
              ),
              color: some 0x000066
            )]
          )
    of "status":
      let
        db = open("../../server/servers.db", "", "", "")
        offdb = open("../../server/offline.db", "", "", "")
        server = db.getAllRows(sql"SELECT host FROM servers").len
        offline = offdb.getAllRows(sql"SELECT host FROM servers").len
        total = server + offline
      discard await discord.api.sendMessage(
        m.channel_id,
        embeds = @[Embed(
          title: some "**Server Database Status**",
          color: some 0x000066,
          fields: some @[EmbedField(
            name: "**Online Servers**",
            value: fmt"```{$server} online servers```"
          ),
          EmbedField(
            name: "**Offline Servers**",
            value: fmt"```{$offline} offline servers```"
          ),
          EmbedField(
            name: "**Total Servers**",
            value: fmt"```{total} total servers```"
          )]
        )]
      )
    of "info":
      discard await discord.api.sendMessage(
        m.channel_id,
        embeds = @[Embed(
          title: some "TaxenHeimer bot",
          description: some "```Discord bot that help to manage TaxenHeimer database queries```",
          color: some 0x000066,
          fields: some @[EmbedField(
            name: "**Author**",
            value: "```TaxMachine```",
            inline: some true
          ),
          EmbedField(
            name: "**Language**",
            value: "```nim```",
            inline: some true
          ),
          EmbedField(
            name: "**Credits**",
            value: "```\nPackage: https://nimble.directory/pkg/dimscord\nHelp: https://discord.gg/nim https://discord.gg/dimscord```"
          )]
        )]
      )

proc guild_member_add(s: Shard, g: Guild, m: Member) {.event(discord).} =
  discard await discord.api.sendMessage(
    "999502028227227810",
    embeds = @[Embed(
      title: some "**Welcome**",
      description: some fmt"Welcome <@{m.user.id}> to TaxenHeimer! Hope you'll have a great time :coffee:",
      color: some 0x000066,
      fields: some @[EmbedField(
        name: "Member Count",
        value: "```\n" & $g.members.len & "\n```"
      )]
    )]
  )
  discard discord.api.addGuildMemberRole(
    g.id,
    m.user.id,
    "999538053943140463",
    "Joining"
  )

proc guild_member_remove(s: Shard, g: Guild, m: Member) {.event(discord).} =
  discard await discord.api.sendMessage(
    "1001391863263150150",
    embeds = @[Embed(
      title: some "**Goodbye**",
      description: some fmt"Goodbye {m.user.username} :brain: :clown:",
      color: some 0x000066,
      fields: some @[EmbedField(
        name: "Member Count",
        value: "```\n" & $g.members.len & "\n```"
      )]
    )]
  )

waitFor discord.startSession()